<template lang="html">
  <div v-if="clients && clients.length">
    <div class="select-list">
      <button v-for="(item, i) in clients" :key="i" @click="selectClient(item.clientId)" :class="{ selected: clientId==item.clientId}">{{ item.name || item.clientId || 'undefined' }}</button>
    </div>
    <flex dir="column" class="content">
      <h1>{{ selectedClient.name || selectedClient.clientId || 'undefined' }} <butter-icon name="edit" @click.native="$emit('editClient', selectedClient.clientId)" width="18" height="18" /></h1>
      <butter-tabs :labels="['Users','Token']" v-slot:default="tabs">
        <butter-table v-if="tabs.activeTab==0" :header="userHeader" :data="userTable" :page="userPage" @cell="$emit('cell', $event)" @paginate="$emit('paginate', $event)" />
        <flex v-if="tabs.activeTab==1" class="columns">
          <butter-input type="textarea" heading="Token" :value="selectedClient.tokens.token" :disabled="true" :copy="true" />
          <butter-input type="textarea" heading="Embed Token" :value="selectedClient.tokens.embedToken" :disabled="true" :copy="true" />
        </flex>
      </butter-tabs>
    </flex>
  </div>
  <flex v-else dir="column" class="clients empty">
    <butter-icon name="person" />
    <p>Your clients list is empty.</p>
  </flex>
</template>

<script>
export default {
  props: {
    'clients': {
      default: () => ([]),
    },
    'users': {
      default: () => ([]),
    },
    'userPage': {
      default: () => ({}),
    },
    'logsPath': {
      default: '/blockset-logs?userId='
    },
    'clientId': {
      default: null
    }
  },
  data() {
    return {
    };
  },
  mounted() {
    if (this.clients.length && !this.clientId) {
      this.selectClient(this.clients[0].clientId);
    }
  },
  computed: {
    userHeader() {
      return [{value: "User #", span: 2}, {value:"Created", span: 3}, {value: "Device ID", span: 6}, {value: "", span: 2}];
    },
    userTable() {
      if (this.users) {
        return this.users.map(u => [{
          value:u.userId,span:2
        },{
          value:u.created,span:3
        },{
          value:u.deviceId,span:6
        },{
          value:"Logs",span:2,href:`${this.logsPath}${u.userId}`
        }]);
      }
    },
    selectedClient() {
      return this.clients.length && this.clients.find(c => c.clientId == this.clientId) || {};
    },
  },
  methods: {
    selectClient(clientId) {
      this.$emit('select', { clientId });
    }
  },
}
</script>
